//
// SeefFill.cpp
//
// ̈hׂ
// @Ƃ{IȃASY
// 
// Written by Nobuki HIRAMINE
// Last modified : 2018/02/18
//

#include <assert.h>	// for assert()
#include "Grid.h"	// for CGrid

#define MAX_STACK_COUNT (10000)

struct Cell
{
	int iX;
	int iY;
};

// X^bNɃZ̒ǉ
static void PushCell( Cell* aCellStack, int& riCountCell, int iX, int iY )
{
	assert( riCountCell < MAX_STACK_COUNT);
	aCellStack[riCountCell].iX = iX;
	aCellStack[riCountCell].iY = iY;
	// Z₷B
	riCountCell++;
}

// X^bNZ̎o
static void PopCell( Cell* aCellStack, int& riCountCell, int& riX, int& riY )
{
	// ZP炷B
	riCountCell--;
	riX = aCellStack[riCountCell].iX;
	riY = aCellStack[riCountCell].iY;
}

void SeedFill( Grid& rGrid, const int iSeedX, const int iSeedY, const char chNew )
{
	if( 0 > iSeedX
		|| rGrid.GetCountX() - 1 < iSeedX
		|| 0 > iSeedY
		|| rGrid.GetCountY() - 1 < iSeedY )
	{	// Obh͈͊ÓAhׂsv
		return;
	}

	// X^bN
	Cell aCellStack[MAX_STACK_COUNT];
	int iCountCell = 0;

	// hׂΏېF
	char chOld = rGrid.GetCell( iSeedX, iSeedY );

	if( chOld == chNew )
	{	// Ώۂ̃ZɐVFȂ΁AhׂsvB
		return;
	}

	// V[hZhׂ\ȏꍇ́AhׂƂƂɁAZX^bNɓo^B
	rGrid.SetCell( iSeedX, iSeedY, chNew );
	PushCell( aCellStack, iCountCell, iSeedX, iSeedY );

	while( iCountCell > 0 )
	{
		// Zo
		int iCellX;
		int iCellY;
		PopCell( aCellStack, iCountCell, iCellX, iCellY );

		// oZ̏㉺E̗אڂS̃ZɂāA
		// hׂ\ׁAhׂ\ȏꍇ́AhׂƂƂɁAZX^bNɓo^B
		if( chOld == rGrid.GetCell( iCellX + 1, iCellY ) )
		{
			rGrid.SetCell( iCellX + 1, iCellY, chNew );
			PushCell( aCellStack, iCountCell, iCellX + 1, iCellY );
		}
		if( chOld == rGrid.GetCell( iCellX, iCellY + 1 ) )
		{
			rGrid.SetCell( iCellX, iCellY + 1, chNew );
			PushCell( aCellStack, iCountCell, iCellX, iCellY + 1 );
		}
		if( chOld == rGrid.GetCell( iCellX - 1, iCellY ) )
		{
			rGrid.SetCell( iCellX - 1, iCellY, chNew );
			PushCell( aCellStack, iCountCell, iCellX - 1, iCellY );
		}
		if( chOld == rGrid.GetCell( iCellX, iCellY - 1 ) )
		{
			rGrid.SetCell( iCellX, iCellY - 1, chNew );
			PushCell( aCellStack, iCountCell, iCellX, iCellY - 1 );
		}
	}
}

